=== lib/Tooling/Inclusions/Stdlib/CMakeLists.txt ===
add_clang_library(clangToolingInclusionsStdlib
  StandardLibrary.cpp

  LINK_LIBS
  clangAST
  )
